<?php
/*
 +--------------------------------------------------------------------------+
 | phpMyBackupPro                                                           |
 +--------------------------------------------------------------------------+
 | Copyright (c) 2004 by Dirk Randhahn                                      |
 | http://sourceforge.net/projects/phpmybackup/                             |
 | Version information can be found in definitions.php.                     |
 |                                                                          |
 | This program is free software; you can redistribute it and/or            |
 | modify it under the terms of the GNU General Public License              |
 | as published by the Free Software Foundation; either version 2           |
 | of the License, or (at your option) any later version.                   |
 |                                                                          |
 | This program is distributed in the hope that it will be useful,          |
 | but WITHOUT ANY WARRANTY; without even the implied warranty of           |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            |
 | GNU General Public License for more details.                             |
 |                                                                          |
 | You should have received a copy of the GNU General Public License        |
 | along with this program; if not, write to the Free Software              |
 | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,USA.|
 +--------------------------------------------------------------------------+
*/

include("login.php");
include_once("definitions.php");

PMBP_print_header(ereg_replace(".*/","",$_SERVER['SCRIPT_NAME']));

// if first use or no db-connection possible
if (!@mysql_connect($CONF['sql_host'],$CONF['sql_user'],$CONF['sql_passwd'])) echo "<div class=\"red_left\">".I_SQL_ERROR."</div><br>";

// generate and print php script
if (isset($_POST['period'])) {
    $path_back="";
    
	// create path to backup.php
	if (strstr($_SERVER['SCRIPT_FILENAME'],"\\")) $delimiter="\\"; else $delimiter="/";
	$script_path=explode($delimiter,$_SERVER['SCRIPT_FILENAME']);
	$path_d=count(explode("..",$_POST['path']))-1;
	$path_u=count(explode($delimiter,$_POST['path']))-$path_d-1;
	for ($i=0;$i<$path_u;$i++) $path_back.="../";
	for ($i=count($script_path)-$path_d-1;$i<count($script_path)-1;$i++) $path_back.=$script_path[$i]."/";

    // generate the dynamic php script
    $result="<?php\n";
    $result.="// This code was created by phpMyBackupPro.".VERSION." \n// http://sourceforge.net/projects/phpmybackup/\n";
    $result.="chdir(\"".$path_back."\");\n";
    $result.="\$file=@file(\"".EXPORT_DIR.DATE_DAT."\");\n";

    // calculate when to backup
    $result.="if (trim(\$file[0])<time()-".(round($_POST['period']*86400)).") {\n";

    // list dbs
    $result.="\t\$_POST['db']=array(";
    if (isset($_POST['db'])) foreach($_POST['db'] as $value) $result.="\"".$value."\", "; else echo "<div class=\"red\">".EXS_NO_DB."!</div>";
    $result.=");\n";

    // print the backup options
    foreach($_POST as $key=>$value) {
        $value=str_replace("\"","'",$value);
        if ($key!="period" && $key!="path" && $key!="db" && $value) $result.="\t\$_POST['".$key."']=\"".$value."\";\n";
    }

    // include the backup.php script to do all the work
    $result.="\t\$_GET['incl']=TRUE;\n";
    #$result.="\t@include \"".$path_back."backup.php\";\n";
	$result.="\t@require \"backup.php\";\n";

    // modify the date.dat file
    $result.="\t\$handle=@fopen(\"".EXPORT_DIR.DATE_DAT."\",\"w\");\n";
    $result.="\t@fwrite(\$handle,time());\n";
    $result.="\t@fclose(\$handle);\n";
    $result.="}\n";
    $result.="?>";

    // show the generated php script
    echo EXS_INCL.":\n<br>(".$_POST['path']."???.php)\n<br><textarea name=\"code\" rows=\"18\" cols=\"79\">".$result."</textarea>\n<br><br>";
    echo "<form name=\"save\" action=\"export_script.php\" method=\"post\">\n";
    
	// list all post variables as hidden fields
    foreach($_POST as $key=>$value) {
		if ($key!="db") echo "<input type=\"hidden\" name=\"".$key."\" value=\"".$value."\">\n";
			else foreach($value as $dbname) echo "<input type=\"hidden\" name=\"".$key."[]\" value=\"".$dbname."\">\n";
    }
    
// save file including the backup script
if (isset($_POST['filename'])) {
	$error=FALSE;
	if ($fp=@fopen($_POST['path'].$_POST['filename'], "w")) {
  		if (@fwrite($fp, $result)) {
			@fclose($fp);
  		} else $error=TRUE;
	} else $error=TRUE;
	if ($error==FALSE) echo "<span class=\"green_left\">".EX_SAVED." ".PMBP_pop_up($_POST['path'].$_POST['filename'],$_POST['path'].$_POST['filename'],"scheduled")."</span><br>\n";
	    else echo "<span class=\"red_left\">".C_WRITE." ".$_POST['path'].$_POST['filename']."</span><br>\n";
}

    echo "<input type=\"text\" name=\"filename\" value=\"???.php\">&nbsp;<input type=\"submit\" value=\"".C_SAVE."\"></form>";
    echo "\n<a href=\"export_script.php\"> <- ".EXS_BACK."</a>\n";
    
// print inscructions and export form
} else {
    echo "<form name=\"backup\" action=\"export_script.php\" method=\"post\">\n<div>\n";
    echo EXS_PERIOD.":<br>\n";
    echo "<select name=\"period\">\n";
    echo "<option value=\"0.0417\">1 ".EXS_HOUR."</option>\n";
    echo "<option value=\"0.25\">6 ".EXS_HOURS."</option>\n";
    echo "<option value=\"0.5\">12 ".EXS_HOURS."</option>\n";
    echo "<option>---------------------</option>\n";
    echo "<option value=\"1\">1 ".EXS_DAY."</option>";
    echo "<option value=\"2\">2 ".EXS_DAYS."</option>\n";
    echo "<option value=\"3\">3 ".EXS_DAYS."</option>\n";
    echo "<option value=\"5\">5 ".EXS_DAYS."</option>\n";
    echo "<option value=\"10\">10 ".EXS_DAYS."</option>\n";
    echo "<option>---------------------</option>\n";
    echo "<option value=\"7\">1 ".EXS_WEEK."</option>\n";
    echo "<option value=\"14\">2 ".EXS_WEEKS."</option>\n";
    echo "<option value=\"21\">3 ".EXS_WEEKS."</option>\n";
    echo "<option>---------------------</option>\n";
    echo "<option value=\"30\">1 ".EXS_MONTH." (30 ".EXS_DAYS.")</option>\n";
    echo"</select>\n<br><br>";

    // get content of these directories (I know, it's redundant - but I think it's required)
    $search_path1="../";
    $dirs1=PMBP_get_dirs($search_path1);
    $search_path2="../../";
    $dirs2=PMBP_get_dirs($search_path2);

    echo EXS_PATH.":<br>\n";
    echo "<select name=\"path\">\n";
    foreach($dirs1 as $value) echo "<option value=\"".$search_path1.$value."\">".$search_path1.$value."</option>\n";
    echo "<option value=\"\">----------------------------</option>\n";
    foreach($dirs2 as $value) echo "<option value=\"".$search_path2.$value."\">".$search_path2.$value."</option>\n";
    echo"</select>\n<br><br>";

    // include the export form (known from the export page)
    PMBP_print_export_form($CONF['sql_host'],$CONF['sql_user'],$CONF['sql_passwd']);
    echo "<br><br>\n<input type=\"submit\" value=\"".EXS_SHOW."\" class=\"button\">\n</div>\n</form>";
}

PMBP_print_footer();
?>
